VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MovieCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private num As Long
Private current As MovieNode

Public Property Get Count() As Long
  Count = num
End Property

Public Property Get FirstM() As Movie
  If current Is Nothing Then
    Set FirstM = Nothing
  Else
    While Not current.PrevM Is Nothing
      Set current = current.PrevM
    Wend
    Set FirstM = current.Movie
  End If
End Property

Public Property Get PrevM() As Movie
  If current Is Nothing Then
    Set PrevM = Nothing
  ElseIf current.PrevM Is Nothing Then
    Set PrevM = Nothing
  Else
    Set current = current.PrevM
    Set PrevM = current.Movie
  End If
End Property

Public Property Get NextM() As Movie
  If current Is Nothing Then
    Set NextM = Nothing
  ElseIf current.NextM Is Nothing Then
    Set NextM = Nothing
  Else
    Set current = current.NextM
    Set NextM = current.Movie
  End If
End Property

Public Property Get LastM() As Movie
  If current Is Nothing Then
    Set LastM = Nothing
  Else
    While Not current.NextM Is Nothing
      Set current = current.NextM
    Wend
    Set LastM = current.Movie
  End If
End Property

Public Property Get Movie() As Movie
  If current Is Nothing Then
    Set Movie = Nothing
  Else
    Set Movie = current.Movie
  End If
End Property

Public Function Find(ByVal Index As String) As Movie
  Dim n As MovieNode, r As Long
  Set n = current
  While Not current Is Nothing
    r = StrComp(Index, current.Movie.Index, vbTextCompare)
    If r = 0 Then
      Set Find = current.Movie
      Exit Function
    ElseIf r < 0 Then
      If StrComp(Index, Left$(current.Movie.Index, Len(Index)), vbTextCompare) = 0 Then
        While Not current.PrevM Is Nothing
          If StrComp(Index, Left$(current.PrevM.Movie.Index, Len(Index)), vbTextCompare) > 0 Then
            Set Find = current.Movie
            Exit Function
          Else
            Set current = current.PrevM
          End If
        Wend
        Set Find = current.Movie
        Exit Function
      Else
        Set current = current.PrevM
      End If
    Else
      Set current = current.NextM
    End If
  Wend
  Set current = n
  Set Find = Nothing
End Function

Public Function Add(ByRef mv As Movie) As Boolean
  Dim n As MovieNode, r As Long
  Add = True
  num = num + 1
  If current Is Nothing Then
    Set current = New MovieNode
    Set current.PrevM = Nothing
    Set current.Movie = mv
    Set current.NextM = Nothing
  Else
    Set n = current
    While Add
      r = StrComp(mv.Index, current.Movie.Index, vbTextCompare)
      If r = 0 Then
        Add = False
      ElseIf r < 0 Then
        If current.PrevM Is Nothing Then
          Set current.PrevM = New MovieNode
          Set current.PrevM.NextM = current
          Set current = current.PrevM
          Set current.Movie = mv
          Exit Function
        ElseIf StrComp(mv.Index, current.PrevM.Movie.Index, vbTextCompare) > 0 Then
          Set n = New MovieNode
          Set n.Movie = mv
          Set n.NextM = current
          Set n.PrevM = current.PrevM
          Set current.PrevM = n
          If Not n.PrevM Is Nothing Then Set n.PrevM.NextM = n
          Set current = n
          Exit Function
        Else
          Set current = current.PrevM
        End If
      Else
        If current.NextM Is Nothing Then
          Set current.NextM = New MovieNode
          Set current.NextM.PrevM = current
          Set current = current.NextM
          Set current.Movie = mv
          Exit Function
        ElseIf StrComp(mv.Index, current.NextM.Movie.Index, vbTextCompare) < 0 Then
          Set n = New MovieNode
          Set n.Movie = mv
          Set n.NextM = current.NextM
          Set n.NextM.PrevM = n
          Set n.PrevM = current
          Set current.NextM = n
          Set current = n
          Exit Function
        Else
          Set current = current.NextM
        End If
      End If
    Wend
    Set current = n
    num = num - 1
  End If
End Function

Public Sub Remove()
  If Not current.NextM Is Nothing Then Set current.NextM.PrevM = current.PrevM
  If Not current.PrevM Is Nothing Then
    Set current.PrevM.NextM = current.NextM
    Set current = current.PrevM
  Else
    Set current = current.NextM
  End If
  num = num - 1
End Sub

Private Sub Class_Initialize()
  num = 0
  Set current = Nothing
End Sub

Private Sub Class_Terminate()
  Set current = Nothing
End Sub
