VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MovieLib"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private movies As MovieCollection
Private datafile As String

Private m_sTitle As String
Private m_lMaxBurn As Long

Public Property Get Title() As String
  Title = m_sTitle
End Property

Public Property Get MaxBurn() As Long
  MaxBurn = m_lMaxBurn
End Property

Public Property Get mCount() As Long
  mCount = movies.Count
End Property

Public Property Get Movie() As Movie
  Set Movie = movies.Movie
End Property

Public Property Let filename(ByVal f As String)
  Dim fso As FileSystemObject, data As TextStream, mv As Movie
  Set fso = New FileSystemObject
  If fso.FileExists(f) Then
    datafile = f
    Set data = fso.OpenTextFile(f)
    Set fso = Nothing
    Title = data.ReadLine
    MaxBurn = data.ReadLine
    While Not data.AtEndOfStream
      Set mv = New Movie
      mv.readFileData data.ReadLine
      If Not movies.Add(mv) Then
        Set mv = Nothing
        data.Close
        Set data = Nothing
        Err.Raise 1 'help!  duplicate indexes somehow got in the file
        Exit Property
      End If
    Wend
    Set mv = Nothing
    data.Close
    Set data = Nothing
  Else
    Set fso = Nothing
    Err.Raise 1 'help!  filename does not exist
  End If
End Property

Private Property Let Title(ByVal t As String)
  m_sTitle = t
End Property

Private Property Let MaxBurn(ByVal mb As Long)
  m_lMaxBurn = mb
End Property

Public Function Add(ByRef mv As Movie) As Boolean
  Add = movies.Add(mv)
End Function

Public Function Find(ByVal Index As String) As Movie
  Set Find = movies.Find(Index)
End Function

Public Sub Remove()
  movies.Remove
End Sub

Public Sub Save()
  SaveAs datafile
End Sub

Public Function FirstMovie() As Movie
  Set FirstMovie = movies.FirstM
End Function

Public Function PrevMovie() As Movie
  Set PrevMovie = movies.PrevM
End Function

Public Function NextMovie() As Movie
  Set NextMovie = movies.NextM
End Function

Public Function LastMovie() As Movie
  Set LastMovie = movies.LastM
End Function

Public Sub SaveAs(ByVal filename As String)
  Dim fso As FileSystemObject, data As TextStream, m As Long
  Set fso = New FileSystemObject
  Set data = fso.CreateTextFile(filename)
  Set fso = Nothing
  With data
    .WriteLine Title
    .WriteLine MaxBurn
    .WriteLine movies.FirstM.toString
    For m = 1 To mCount - 1
      .WriteLine movies.NextM.toString
    Next m
    .Close
  End With
  Set data = Nothing
End Sub

Public Sub writeHTML(ByVal htmlfile As String, ByVal columns As mvColumn)
  Dim fso As FileSystemObject, data As TextStream, mv As Movie, i As String
  Set fso = New FileSystemObject
  Set data = fso.CreateTextFile(htmlfile)
  Set fso = Nothing
  With data
'    .WriteLine "      span { height: 100%; width: 100%; cursor: pointer;}"
    .WriteLine "<!DOCTYPE HTML PUBLIC ""-//W3C//DTD HTML 4.01 Transitional//EN"">" & vbCrLf & _
               "<html>" & vbCrLf & _
               "  <head>" & vbCrLf & _
               "    <meta http-equiv=Content-Type content=""text/html; charset=iso-8859-1"">" & vbCrLf & _
               "    <style type=text/css>" & vbCrLf & _
               "      a {text-decoration: none; font-weight: bold;}" & vbCrLf & _
               "      a:link {color: #3377aa;}" & vbCrLf & _
               "      a:active {color: #000000;}" & vbCrLf & _
               "      a:visited {color: #2c2c2c;}" & vbCrLf & _
               "      a:hover {text-decoration: underline;}" & vbCrLf & _
               "      body {font-family: ms sans serif; font-size: x-small; color: #666666; text-align: justify; background-color: #4a4a4a; margin-top: 20px; margin-left: 0px; margin-right: 0px; margin-bottom: 20px;}" & vbCrLf & _
               "      div.center {position: absolute; top: 20px; left: 0px; width: 100%; text-align: center;}" & vbCrLf & _
               "      div.main {font-family: ms sans serif; font-size: x-small; color: #666666; text-align: justify; background-color: #ffffff; width: 600px; margin-bottom: 20px; padding-top: 0px; padding-left: 0px; padding-right: 0px; padding-bottom: 0px; border-top: 3px solid #000000; border-left: 3px solid #000000; border-right: 3px solid #000000; border-bottom: 3px solid #000000;}" & vbCrLf & _
               "      div.title {font-weight: bold; font-size: large; color: #000000; text-align: center; padding-top: 10px; padding-bottom: 10px; border-bottom: 3px solid #000000;}" & vbCrLf & _
               "      div.sub {font-size: small; text-align: center; font-weight: bold; color: #ffffff; background-color: #666666; padding-top: 2px; padding-bottom: 2px; margin-top: 20px;}" & vbCrLf & _
               "      table {width: 100%;}" & vbCrLf & _
               "      th {background-color: #b2d2ff; color: #333333; border-top: 1px solid #cceeff; border-left: 1px solid #cceeff; border-right: 1px solid #3377aa; border-bottom: 1px solid #3377aa;}" & vbCrLf & _
               "      td {background-color: #e8e8e8; padding-left: 5px; padding-right: 5px;}" & vbCrLf & _
               "      span {width: 100%; height: 100%; cursor: pointer;}" & vbCrLf & _
               "    </style>" & vbCrLf & _
               "    <title>" & Title & "</title>" & vbCrLf & _
               "  </head>"
    .WriteLine "  <body>" & vbCrLf & _
               "    <div class=center><center><div class=main>" & vbCrLf & _
               "      <div class=title>" & Title & "</div>" & vbCrLf & _
               "      <table>" & vbCrLf
    .Write "        <tr><th>title</th>"
    If (columns And mvcDiscs) = mvcDiscs Then .Write "<th>#</th>"
    If (columns And mvcSize) = mvcSize Then .Write "<th>bytes</th>"
    If (columns And mvcTime) = mvcTime Then .Write "<th>time</th>"
    If (columns And mvcResolution) = mvcResolution Then .Write "<th>res</th>"
    If (columns And mvcYear) = mvcYear Then .Write "<th>year</th>"
    If (columns And mvcCD) = mvcCD Then .Write "<th>on cd</th>"
    If (columns And mvcHD) = mvcHD Then .Write "<th>online</th>"
    If (columns And mvcVideoCodec) = mvcVideoCodec Then .Write "<th>video</th>"
    If (columns And mvcVBR) = mvcVBR Then .Write "<th>vbr</th>"
    If (columns And mvcAudioCodec) = mvcAudioCodec Then .Write "<th>audio</th>"
    If (columns And mvcABR) = mvcABR Then .Write "<th>abr</th>"
    .WriteLine "</tr>"
    i = movies.Movie.Index
    Set mv = movies.FirstM
    While Not mv Is Nothing
      .WriteLine mv.HTML(columns)
      Set mv = movies.NextM
    Wend
    Call movies.Find(i)
    Set mv = Nothing
    .WriteLine "      </table>" & vbCrLf & _
               "    </div></center></div>" & vbCrLf & _
               "  </body>" & vbCrLf & _
               "</html>"
    .Close
  End With
  Set data = Nothing
End Sub

Private Sub Class_Initialize()
  Set movies = New MovieCollection
End Sub

Private Sub Class_Terminate()
  Set movies = Nothing
End Sub
